﻿If (-NOT ([Security.Principal.WindowsPrincipal] [Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole]::Administrator))
{
  #Relaunch as an elevated process:
  Start-Process powershell.exe "-File",('"{0}"' -f $MyInvocation.MyCommand.Path) -Verb RunAs
  exit
}

Write-Output "*****************************************************************************"
Write-Output "MAG*3.0*P326 Log4Shell Patch:  December 2021 Log4j exploit (CVE-2021-44228)."
Write-Output "This script will do the following operations:"
Write-Output "  1) Stop the Apache Tomcat service"
Write-Output "  2) Back up and remove the affected log4j files"
Write-Output "  3) Add the fixed log4j .jar files"
Write-Output "  4) Restart Apache Tomcat"
Write-Output "*****************************************************************************`n`n"

$Global:varJavaPath = "C:\Program Files\Java\jre1.8.0_251\lib\ext"

function set-java {
    
      $var251JavaPath = "C:\Program Files\Java\jre1.8.0_251\lib\ext"
      $var291JavaPath = "C:\Program Files\Java\jre1.8.0_291\lib\ext"
        
      if (Test-Path $var251JavaPath)
      {
          $Global:varJavaPath = $var251JavaPath
          Write-Output "Using java version 251"
      }
     
      if (Test-Path $var291JavaPath)
      {
          $Global:varJavaPath = $var291JavaPath
          Write-Output "Using java version 291"
      }  
}

function stop-tomcat {

    $confirmStop = Read-Host "Do you want to stop Tomcat (Y/N)?"

    if ($confirmStop -eq "Y")
    {
        $tomcatname = "Tomcat9"
        $startTime = (Get-Date)

        #Shut down and restart Tomcat Service
        #Pre-shutdown statuses
        $tomcatpid = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty ProcessId
        $tomcatstatus = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty Status
        $tomcatstate = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty State

        echo "***** $tomcatname Service *****"       
        echo "$tomcatname Status:  $tomcatstatus"
        echo " $tomcatname State:  $tomcatstate"
        echo "   $tomcatname PID:  $tomcatpid"

        #check state
        #if "Running", proceed to shutdown.  if not skip and move to step 2.
        if ($tomcatstate -eq 'Running') {
	        echo "$tomcatname service is running.  Stopping service..."
	        Stop-Service -Name "$tomcatname" -Force
	        #verifying service stopped
	        Start-Sleep -s 10
	        $tomcatstate2 = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty State
	        echo "$tomcatname is $tomcatstate2"
	        if ($tomcatstate2 -eq 'Stopped') {
                $elapsedTime = $(Get-Date) - $StartTime
                $totalTime = "{0:mm:ss.fff}" -f ([datetime]$elapsedTime.Ticks)
		        echo "$tomcatname service successfully stopped in $($totalTime).  Proceeding to step 2."
	        }
        }
    }
}



function backup-log4j {

    $confirmBackup = Read-Host "Do you want to back up and remove files (Y/N)?"

    if ($confirmBackup -eq "Y")
    {
        $arrFiles = @("log4j-api-2.11.0.jar", "log4j-core-2.11.0.jar", "log4j-slf4j-impl-2.11.0.jar")
        $varApachePath = "C:\Program Files\Apache Software Foundation\Tomcat 9.0\lib"
        $varHFPath = "C:\temp\p326_Log4Shell_Patch"
        $varBackupPath = "$($varHFPath)\Backup_" + (Get-Date -Format yyyyMMdd_hhmm)

        Write-Output "Copying backups to $varBackupPath"
        New-Item -ItemType Directory -Force -Path $varBackupPath
        foreach  ($varFile in $arrFiles)
        {
            Copy-Item -Path $varApachePath\$varFile -Destination $varBackupPath
        }

        Write-Output "Deleting original log4j files from $varApachePath"
        foreach ($varFile in $arrFiles)
        {
            $varFullFilePath = "$varApachePath\$varFile"
            Write-Output $varFullFilePath

            if (Test-Path $varFullFilePath) {
                Remove-Item -Path $varFullFilePath
                Write-Output "$varFile has been successfully deleted."
            }else{
                Write-Output "$varAPI does not exist."
            }
        }

        Write-Output "Deleting original log4j files from $Global:varJavaPath"
        foreach ($varFile in $arrFiles)
        {
            $varFullFilePath = "$Global:varJavaPath\$varFile"
            if (Test-Path $varFullFilePath) {
                Remove-Item -Path $varFullFilePath
                Write-Output "$varFile has been successfully deleted."
            }else{
                Write-Output "$varAPI does not exist."
            }
        }
    }
}



function copy-log4j {

    $confirmCopy = Read-Host "Do you want to add the fixed files (Y/N)?"

    if ($confirmCopy -eq "Y")
    {
        $arrFiles = @("log4j-api-2.17.0.jar", "log4j-core-2.17.0.jar", "log4j-slf4j-impl-2.17.0.jar")
        $varApachePath = "C:\Program Files\Apache Software Foundation\Tomcat 9.0\lib"
        $varHFPath = "C:\temp\p326_Log4Shell_Patch"
        $varPatchedPath = $PSScriptRoot

        Write-Output "Copying the fixed files to $varApachePath"
        foreach  ($varFile in $arrFiles)
        {
            $varFullFilePath = "$varPatchedPath\bin\$varFile"
            Copy-Item -Path $varFullFilePath -Destination $varApachePath
        }

        Write-Output "Copying the fixed files to $Global:varJavaPath"
        foreach  ($varFile in $arrFiles)
        {
            $varFullFilePath = "$varPatchedPath\bin\$varFile"
            Copy-Item -Path $varFullFilePath -Destination $Global:varJavaPath
        }
    }
}



function start-tomcat {

    $confirmStart = Read-Host "Do you want to start Tomcat (Y/N)?"

    if ($confirmStart -eq "Y")
    {
        $tomcatname = "Tomcat9"

	    echo "$tomcatname is not running.  This is expected."
	    echo "Attempting to start $tomcatname service.  Starting service..."
	    Start-Service -Name "$tomcatname"
	    #verifying service started
	    Start-Sleep -s 10
	    $tomcatstate3 = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty State
	    echo "$tomcatname is $tomcatstate3"
	    if ($tomcatstate3 -eq 'Running') {
		    echo "$tomcatname service successfully restarted."
	    }	
    }
    #Post-restart statuses
    $prs_tomcatpid = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty ProcessId
    $prs_tomcatstatus = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty Status
    $prs_tomcatstate = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty State

    echo "***** $tomcatname Service *****"
    echo "$tomcatname Status:  $prs_tomcatstatus"
    echo " $tomcatname State:  $prs_tomcatstate"
    echo "   $tomcatname PID:  $prs_tomcatpid"
}

# 1) Set the java version number
set-java

# 2) Stop the Apache Tomcat service
Write-Warning "1) Stop the Apache Tomcat service."
stop-tomcat

# 3) Back up and remove the affected log4j files
Write-Warning "2) Back up and remove the affected log4j files."
backup-log4j

# 4) Add the fixed log4j .jar files
Write-Warning "3) Add the fixed log4j .jar files."
copy-log4j

# 5) Restart Apache Tomcat
Write-Warning "4) Restart Apache Tomcat."
start-tomcat

Write-Warning "p326 log4shell patch script complete."